找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1680|回复: 0

[分享] Displaying entities in different colors using DrawableOverrule

[复制链接]

已领礼包: 593个

财富等级: 财运亨通

发表于 2013-5-27 00:17:22 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
Displaying entities in different colors using DrawableOverrule                                                        By Balaji Ramamoorthy
Recently, a developer wanted to know a method to display the entities in different colors to visually represent the results of a drawing comparison. A way to set the color for entities including those that are nested is explained in Kean's blog post :
Changing the colour of nested AutoCAD entities through .NETAnother way to show the entity in different colors would be to use of DrawableOverrule. But, the WorldDraw of the DrawableOverrule class does not use the color setting from the DrawableTraits for some entities such as MText. To overcome this limitation, the drawable is cloned inside the WorldDraw method before being assigned a new color.
Here is a sample code using this approach. Some of the helper methods to highlight / unhighlight and pick nested entities are from Kean's blog post that I mentioned about previously.
  1. using Autodesk.AutoCAD.GraphicsInterface;
  2. using System.Collections.Generic;

  3. public class MyDrawOverrule : DrawableOverrule
  4. {
  5.     public static List<ObjectId> _redIds = new List<ObjectId>();
  6.     public static List<ObjectId> _yellowIds = new List<ObjectId>();
  7.     public override bool WorldDraw(Drawable drawable, WorldDraw wd)
  8.     {
  9.         Entity mydrawable = drawable.Clone() as Entity;
  10.         short colorIndex = 1;
  11.         if (_yellowIds.Contains(drawable.Id))
  12.             colorIndex = 2;
  13.         wd.SubEntityTraits.Color = colorIndex;
  14.         mydrawable.ColorIndex = colorIndex;
  15.         return base.WorldDraw(mydrawable, wd);
  16.     }
  17.     public override int SetAttributes(Drawable drawable,
  18.                                         DrawableTraits traits)
  19.     {
  20.         return base.SetAttributes(drawable, traits);
  21.     }
  22. }

  23. public class ColorizeClass : IExtensionApplication
  24. {
  25.     static MyDrawOverrule _do = null;
  26.     [CommandMethod("Colorize")]
  27.     public void ColorizeMethod()
  28.     {
  29.         Document doc = Application.DocumentManager.MdiActiveDocument;
  30.         Editor ed = doc.Editor;
  31.         if (_do != null)
  32.         {
  33.             ed.WriteMessage("Overruling is already active");
  34.             return;
  35.         }
  36.         Transaction tr = doc.TransactionManager.StartTransaction();
  37.         using (tr)
  38.         {
  39.             List<FullSubentityPath> paths1;
  40.             SelectNestedEntities(   ed,
  41.                                     out MyDrawOverrule._redIds,
  42.                                     out paths1,
  43.                                     "Red"
  44.                                 );
  45.             List<FullSubentityPath> paths2;
  46.             SelectNestedEntities(  ed,
  47.                                     out MyDrawOverrule._yellowIds,
  48.                                     out paths2,
  49.                                     "Yellow"
  50.                                  );
  51.             _do = new MyDrawOverrule();
  52.             Overrule.AddOverrule(
  53.                 RXObject.GetClass(typeof(Entity)),
  54.                 _do,
  55.                 true);
  56.             List<ObjectId> ids = new List<ObjectId>();
  57.             ids.AddRange(MyDrawOverrule._redIds.ToArray());
  58.             ids.AddRange(MyDrawOverrule._yellowIds.ToArray());
  59.             _do.SetIdFilter(ids.ToArray());
  60.             Overrule.Overruling = true;
  61.             if (MyDrawOverrule._redIds.Count > 0)
  62.                 UnhighlightSubEntities(paths1);
  63.             if (MyDrawOverrule._yellowIds.Count > 0)
  64.                 UnhighlightSubEntities(paths2);
  65.             tr.Commit();
  66.         }
  67.         ed.Regen();
  68.     }
  69.     private static bool SelectNestedEntities
  70.         (
  71.             Editor ed,
  72.             out List<ObjectId> ids,
  73.             out List<FullSubentityPath> paths,
  74.             String colorName
  75.         )
  76.     {
  77.         ids = new List<ObjectId>();
  78.         paths = new List<FullSubentityPath>();

  79.         // Loop until cancelled or completed

  80.         PromptNestedEntityResult rs;
  81.         do
  82.         {
  83.             rs = ed.GetNestedEntity(
  84.                 String.Format("\nSelect entity to color {0}: ",
  85.                 colorName));
  86.             if (rs.Status == PromptStatus.OK)
  87.             {
  88.                 ids.Add(rs.ObjectId);
  89.                 FullSubentityPath path = FullSubentityPath.Null;
  90.                 path = HighlightSubEntity(rs);
  91.                 if (path != FullSubentityPath.Null)
  92.                     paths.Add(path);
  93.             }
  94.         } while (rs.Status == PromptStatus.OK);
  95.         return (rs.Status == PromptStatus.Cancel);
  96.     }

  97.     // Ask the user to select a number of sub-entities.
  98.     // These will have their ObjectIds and their sub-entity
  99.     // paths (returned from the HighlightSubEntity() helper)
  100.     // added to collections that are returned to the caller.

  101.     private static bool SelectNestedEntities
  102.         (
  103.             Editor ed,
  104.             out ObjectIdCollection ids,
  105.             out List<FullSubentityPath> paths
  106.         )
  107.     {

  108.         ids = new ObjectIdCollection();
  109.         paths = new List<FullSubentityPath>();

  110.         // Loop until cancelled or completed

  111.         PromptNestedEntityResult rs;
  112.         do
  113.         {
  114.             rs = ed.GetNestedEntity("\nSelect nested entity: ");
  115.             if (rs.Status == PromptStatus.OK)
  116.             {
  117.                 ids.Add(rs.ObjectId);
  118.                 FullSubentityPath path = FullSubentityPath.Null;
  119.                 path = HighlightSubEntity(rs);
  120.                 if (path != FullSubentityPath.Null)
  121.                     paths.Add(path);
  122.             }
  123.         } while (rs.Status == PromptStatus.OK);

  124.         // Cancel is the status when "enter" is used to
  125.         // terminate the selection, which means we can't
  126.         // use it to distinguish from an actual
  127.         // cancellation.

  128.         return (rs.Status == PromptStatus.Cancel);
  129.     }

  130.     // Unhighlight a set of sub-entities

  131.     private static void UnhighlightSubEntities(
  132.                                 List<FullSubentityPath> paths)
  133.     {
  134.         for (int i = 0; i < paths.Count; i++)
  135.         {
  136.             ObjectId[] ids = paths.GetObjectIds();
  137.             Entity ent
  138.                 = ids[0].GetObject(OpenMode.ForRead) as Entity;
  139.             if (ent != null)
  140.             {
  141.                 ent.Unhighlight(paths, false);
  142.             }
  143.         }
  144.     }

  145.     // Highlight a sub-entity based on its nested
  146.     // selection information.
  147.     // Return the calculated sub-entity path, so
  148.     // the calling application can later unhighlight.

  149.     private static FullSubentityPath HighlightSubEntity(
  150.                                     PromptNestedEntityResult rs)
  151.     {

  152.         // Extract relevant information from the prompt object

  153.         ObjectId selId = rs.ObjectId;
  154.         List<ObjectId> objIds = new List<ObjectId>(rs.GetContainers());

  155.         // Reverse the "containers" list

  156.         objIds.Reverse();

  157.         // Now append the selected entity

  158.         objIds.Add(selId);

  159.         // Retrieve the sub-entity path for this entity

  160.         SubentityId subEnt
  161.             = new SubentityId(SubentityType.Null, System.IntPtr.Zero);
  162.         FullSubentityPath path
  163.             = new FullSubentityPath(objIds.ToArray(), subEnt);

  164.         // Open the outermost container, relying on the open transaction...

  165.         Entity ent = objIds[0].GetObject(OpenMode.ForRead) as Entity;
  166.         // ... and highlight the nested entity
  167.         if (ent == null)
  168.             return FullSubentityPath.Null;
  169.         ent.Highlight(path, false);
  170.         // Return the sub-entity path for later unhighlighting
  171.         return path;
  172.     }
  173.     void IExtensionApplication.Initialize() { }
  174.     void IExtensionApplication.Terminate()
  175.     {
  176.         if (_do != null)
  177.         {
  178.             Overrule.Overruling = false;
  179.             Overrule.RemoveOverrule(
  180.                 RXObject.GetClass(typeof(Entity)),
  181.                 _do);
  182.         }
  183.     }
  184. }


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-5 20:30 , Processed in 0.385057 second(s), 31 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表